// -*- C++ -*- (c) 2008 Petr Rockai <me@mornfall.net>

#include <QtGui/QStandardItemModel>
#include <QtCore/QCoreApplication>

#ifndef EPT_TOKENMODEL_H
#define EPT_TOKENMODEL_H

namespace adept {

class TokenModel : public QStandardItemModel
{
    bool m_fillPending, m_fillRunning;
    int m_fillLevel;

public:
    template< typename List >
    void fillFrom( List l ) {
        ++ m_fillLevel;
        int level = m_fillLevel;

        int i = 0;
        while ( !l.empty() ) {
            QVariant v;
            v.setValue( l.head().token() );

            QStandardItem *current = item( i );

            if ( !current ) {
                current = new QStandardItem();
                appendRow( current );
            }

            current->setData( v );
            l = l.tail();

            /* This can increase level, in which case we immediately
             * drop out of the loop. The recursive call from within
             * processEvents() has re-filled the list, so we have
             * nothing more to do. */
            if ( i % 20 == 0 ) {
                QCoreApplication::processEvents();
                if ( m_fillLevel > level ) {
                    -- m_fillLevel;
                    return;
                }
            }

            ++ i;
        }
        setRowCount( i );
    }

    TokenModel() : m_fillLevel( 0 ) {}
};

}

#endif
